server
{
  server_name local.testpages.adblockplus.org;

  listen 127.0.0.1:443 ssl http2 default_server;

  ssl_certificate local.testpages.adblockplus.org_cert.pem;
  ssl_certificate_key local.testpages.adblockplus.org_key.pem;
  ssl_dhparam C:/tools/nginx-1.19.0/conf/dhparam.pem;
  add_header Strict-Transport-Security max-age=31536000;

  access_log C:/tools/nginx-1.19.0/logs/access.local.testpages.adblockplus.org.log;

  # redirect server error pages to the static page /50x.html
  error_page 500 502 503 504 /50x.html;
  location = /50x.html
  {
    root C:/tools/nginx-1.19.0/html;
  }

  if ($http_host ~ "^(.+)\.$")
  {
    set $canonical_host $1;
    rewrite ^(.*) $scheme://$canonical_host$1 permanent;
  }

  root C:/tools/nginx-1.19.0/html/local.testpages.adblockplus.org;
  index index;
  default_type text/html;
  charset utf-8;

  set $index_page "index";

  location /
  {
    expires 1d;

    # Redirect server/language root

    rewrite ^/$ /$index_page last;
    rewrite ^/(\w\w(_\w\w)?)$ /$1/ permanent;
    rewrite ^/(\w\w(_\w\w)?)/$ /$1/$index_page last;

    # Match Accept-Language header against available languages
    set $preferredLang en;
    set $preferredRegion "";
    if ($http_accept_language ~ ^(\w\w)\b)
    {
      set $preferredLang $1;
    }
    if ($http_accept_language ~ ^\w\w-(\w\w)\b)
    {
      set $preferredRegion $1;
    }

    if ($arg_fb_locale ~ ^(\w\w)_(\w\w)$)
    {
      set $preferredLang $1;
      set $preferredRegion $2;
    }

    # Redirect canonical URLs to language-specific versions
    if (-e "$document_root/${preferredLang}_$preferredRegion$uri")
    {
      rewrite ^(.*) /${preferredLang}_$preferredRegion$1 last;
    }
    if (-e "$document_root/$preferredLang$uri")
    {
      rewrite ^(.*) /$preferredLang$1 last;
    }
    if (-e "$document_root/en$uri")
    {
      rewrite ^(.*) /en$1 last;
    }
  }
}
